drop table if exists #Dups;
go

select s.CustomerID
into #Dups
from tempdb.dbo.Selection1 s
group by s.CustomerID
having count(*) > 1;
go

-- Delete all rows identified as duplicates,
-- then re-add the same rows one time.
begin try;
	begin transaction;

	delete s
	from tempdb.dbo.Selection1 s
	inner join #Dups d on s.CustomerID = d.CustomerID;

	insert tempdb.dbo.Selection1 (CustomerID)
	select CustomerID
	from #Dups;

	commit transaction;
end try
begin catch
	rollback transaction;
	raiserror ('Ack!!', 16, 1);
end catch;

go
-- Validate no duplicates remain
select CustomerID
from tempdb.dbo.Selection1
group by CustomerID
having count(*) > 1;

select count(*) NbrRows
from tempdb.dbo.Selection1;
-- 285977