use CorpDB;
go
drop table if exists #fn;
go
select c.FirstName
into #fn
from dbo.Customer c;
go
select count(distinct FirstName) from #fn;
go
-- One way to delete: temp table
drop table if exists #fn_distinct;
go
select distinct #fn.FirstName
into #fn_distinct
from #fn;
go
delete fn
from #fn fn
inner join #fn_distinct fnd on fn.FirstName = fnd.FirstName;
go
insert #fn (FirstName)
select FirstName
from #fn_distinct;
go
-- More efficient:
drop table if exists #fn;
go
select c.FirstName
into #fn
from dbo.Customer c;
go
with fn_row_num as
(
	select FirstName,
		row_number() over (partition by FirstName order by FirstName) rn
	from #fn
)
delete fn_row_num
where rn > 1;
go
-- Or how about this?:
drop table if exists #fn;
go
select c.FirstName
into #fn
from dbo.Customer c;
go
with fn_row_num as
(
	select row_number() over (partition by FirstName order by FirstName) rn
	from #fn
)
delete fn_row_num
where rn > 1;
